/*SpUpd!_2020.02.19_0000008*/
/*needVer=2020.02.10_0000007*/

CREATE OR ALTER procedure GET_INFO_SLUCH (
    IDCASE integer)
returns (
    SUMV numeric(15,2),
    POLIS varchar(30),
    NHISTORY varchar(50),
    DATE_1 date,
    DATE_2 date,
    DS varchar(10),
    USL_OK varchar(200),
    DR date)
as
begin
select 
--s.mtlcostmtl
sum(m.cost_sf), trim(trim(s.seria)||' '||trim(s.number)) polis, s.nomib, s.in_stac, s.out_stac, s.stac_diags,
iif(r.tip_stac=1,case r.oplat when 1 then ', '
when 6 then ', '
when 7 then ', ' end,
case r.tip_stac when 2 then '  '
when 3 then '  '
when 4 then '  ' end) ts, s.dr from stacion s
join mtl m on m.id_ill = s.id_ill
join reports r on r.repn=s.repn and m.oplat = r.oplat
where s.id_ill=:idcase
group by polis, s.nomib, s.in_stac, s.out_stac, s.stac_diags, ts, s.dr
into :sumv, :polis, :nhistory, :date_1, :date_2, :ds, :usl_ok, :dr;
suspend;
end;
@
CREATE OR ALTER procedure GET_INFO_SCHET (
    MCOD integer,
    DATE_1 date,
    DATE_2 date,
    USL_OK smallint,
    SMO integer,
    IS_MEK integer,
    IS_PD integer)
returns (
    SUMMAV numeric(15,2),
    SL_COUNT integer,
    ED_COL integer)
as
begin
select sum(T.SUMV), sum(T.SID), sum(T.KDMTL)
from (
select
    R.REPN,
    --sum(S.MTLCOSTMTL) as SUMV,
    sum(m.cost_sf) as SUMV,
    cast(count(distinct S.ID_ILL) as integer) SID,
    sum(m.kdoms) KDMTL
    --sum(s.kdmtl) KDMTL
from STACION S
join REPORTS R on R.REPN = S.REPN
join mtl m on m.id_ill = s.id_ill and m.oplat = r.oplat
join LPU_MCOD LM on LM.LPU_ID = R.LPU
where (R.SEE1 = 1) and
(R.SEE2 = 1) and
(R.DATE_END between :DATE_1 and :DATE_2) and
(LM.MCOD = cast(:MCOD as char(6))) and
(
((r.oplat=6) and (:usl_ok=11)) or                   --
((r.oplat=7) and (:usl_ok=12)) or                   --
--((r.tip_stac=1) and (:usl_ok=1)) or               --
((r.tip_stac=1) and (r.oplat=1) and (:usl_ok=1)) or --,  
((r.tip_stac in (2,3,4)) and (:usl_ok=2)) or        --
((r.tip_stac=2) and (:usl_ok=22)) or                -- .
((r.tip_stac=3) and (:usl_ok=23)) or                -- 
((r.tip_stac=4) and (:usl_ok=24))                   -- 
) and
((:IS_MEK = 0) or ((:IS_MEK = 1) and
(S.SUM_MEK is null)) or ((:IS_MEK = 2) and
(not S.SUM_MEK is null))) and
(:SMO=0 or (:SMO=1 and r.inogor=0) or (:SMO=45 and r.inogor=1) or (:SMO=45001 and s.polis=2778) or (:SMO=45002 and s.polis=2779)) and
(:IS_PD=0 or (:IS_PD=1 and s.polis<>'') or (:IS_PD=2 and s.polis=''))
group by R.REPN) T
into :SUMMAV, :SL_COUNT, :ED_COL;
suspend;
end;
@
CREATE OR ALTER procedure SP_ANALIZ (
    REPN1 integer,
    REPN2 integer,
    REPN3 integer,
    REPN4 integer)
returns (
    FAMILY char(30),
    NAME char(20),
    FATHER char(30),
    DR date,
    MTLCOSTMTL numeric(15,2),
    NOMIB varchar(50),
    KOL integer,
    ID_ILL integer,
    SMOCOD varchar(5),
    LPU_MCOD varchar(6),
    REP_DATE_END date,
    TIP_STAC integer,
    REPN integer,
    SUM_MEK numeric(15,2))
as
declare variable P_ID_ILL integer;
begin
for select s.FAMILY, s.NAME, s.FATHER, s.DR, s.MTLCOSTMTL, s.NOMIB, s.ID_ILL, smo.smocod, l.mcod, r.repn, r.date_end, r.tip_stac, s.sum_mek
from STACION s
join reports r on r.repn=s.repn
join lpu l on l.id = r.lpu
join mtl m on m.id_ill = s.id_ill
left join smo on smo.o_cod=s.polis
where (s.REPN=:repn1 or s.REPN=:repn2 or s.REPN=:repn3 or s.REPN=:repn4)
group by s.FAMILY, s.NAME, s.FATHER, s.DR, s.MTLCOSTMTL, s.NOMIB, s.ID_ILL, smo.smocod, l.mcod, r.repn, r.date_end, s.SUM_MEK, r.tip_stac
into :FAMILY, :NAME, :FATHER, :DR, :MTLCOSTMTL, :NOMIB, :p_id_ill, :SMOCOD, :LPU_MCOD, :repn, :REP_DATE_END, :TIP_STAC, :SUM_MEK
do
begin
id_ill=p_id_ill;
EXECUTE PROCEDURE sp_kol_mtl_1 (:p_ID_ILL)
RETURNING_VALUES(:kol);
suspend;
end
end;
@
CREATE OR ALTER procedure BUILD_MONTH (
    PLAN_IDX integer)
as
declare variable I integer;
declare variable RY integer;
declare variable GY integer;
declare variable KY integer;
declare variable SY integer;
declare variable PG_RY integer;
declare variable PG_GY integer;
declare variable PG_KY integer;
declare variable PG_SY integer;
declare variable SUM_R numeric(15,2);
declare variable SUM_S numeric(15,2);
declare variable SUM_G numeric(15,2);
declare variable SUM_K numeric(15,2);
declare variable AVG_GOSP_R numeric(15,2);
declare variable AVG_GOSP_S numeric(15,2);
declare variable AVG_GOSP_G numeric(15,2);
declare variable AVG_GOSP_K numeric(15,2);
declare variable KMAX_COST_R numeric(15,2);
declare variable KMAX_COST_G numeric(15,2);
declare variable KMAX_COST_K numeric(15,2);
declare variable KMAX_COST_S numeric(15,2);
declare variable KMAX_GOSP_R smallint;
declare variable KMAX_GOSP_S smallint;
declare variable KMAX_GOSP_G smallint;
declare variable KMAX_GOSP_K smallint;
declare variable KMAX_KD_R smallint;
declare variable BONCOST_R smallint;
declare variable BONCOST_S smallint;
declare variable BONCOST_G smallint;
declare variable BONCOST_K smallint;
declare variable BONGOSP_R smallint;
declare variable BONGOSP_S smallint;
declare variable BONGOSP_G smallint;
declare variable BONGOSP_K smallint;
declare variable BONUS_KD smallint;
declare variable RY_M integer;
declare variable SY_M integer;
declare variable GY_M integer;
declare variable KY_M integer;
declare variable SUM_RM numeric(15,2);
declare variable SUM_SM numeric(15,2);
declare variable SUM_GM numeric(15,2);
declare variable SUM_KM numeric(15,2);
declare variable PG_RYM integer;
declare variable PG_SYM integer;
declare variable PG_GYM integer;
declare variable PG_KYM integer;
declare variable MAX_IS_LEFT smallint;
begin
select coalesce(RY,0),coalesce(GY,0),coalesce(KY,0),coalesce(SY,0),coalesce(PG_RY,0),coalesce(PG_GY,0),coalesce(PG_KY,0),coalesce(PG_SY,0),
       coalesce(sum_ry,0),coalesce(sum_sy,0),coalesce(sum_gy,0),coalesce(sum_ky,0) from planindex p
where p.id=:plan_idx
into :ry,:gy,:ky,:sy,:pg_ry,:pg_gy,:pg_ky,:pg_sy,:sum_r,:sum_s,:sum_g,:sum_k;
i=1;
if (not (exists (select id from plan2month where plan_idx=:plan_idx))) then
begin
sum_rm=trunc(sum_r/12*100)/100;
sum_sm=trunc(sum_s/12*100)/100;
sum_gm=trunc(sum_g/12*100)/100;
sum_km=trunc(sum_k/12*100)/100;
pg_rym=trunc(pg_ry/12);
pg_sym=trunc(pg_sy/12);
pg_gym=trunc(pg_gy/12);
pg_kym=trunc(pg_ky/12);
ry_m=trunc(ry/12);
sy_m=trunc(sy/12);
gy_m=trunc(gy/12);
ky_m=trunc(ky/12);
max_is_left=0;
while (i<=12) do
begin
if (i-1=round((sum_r-sum_rm*12)*100)) then sum_rm=sum_rm-0.01;
if (i-1=round((sum_s-sum_sm*12)*100)) then sum_sm=sum_sm-0.01;
if (i-1=round((sum_g-sum_gm*12)*100)) then sum_gm=sum_gm-0.01;
if (i-1=round((sum_k-sum_km*12)*100)) then sum_km=sum_km-0.01;
if (i-1=(pg_ry-pg_rym*12)) then pg_rym=:pg_rym-1;
if (i-1=(pg_sy-pg_sym*12)) then pg_sym=:pg_sym-1;
if (i-1=(pg_gy-pg_gym*12)) then pg_gym=:pg_gym-1;
if (i-1=(pg_ky-pg_kym*12)) then pg_kym=:pg_kym-1;
if (i-1=(ry-ry_m*12)) then ry_m=ry_m-1;
if (i-1=(sy-sy_m*12)) then sy_m=sy_m-1;
if (i-1=(gy-gy_m*12)) then gy_m=gy_m-1;
if (i-1=(ky-ky_m*12)) then ky_m=ky_m-1;
insert into plan2month (plan_idx,n_month,ry_m,gy_m,ky_m, sy_m, sum_r,sum_g,sum_k, sum_s, pgs_m,pgr_m,pgg_m,pgk_m)
values (:plan_idx,:i,:ry_m+1,:gy_m+1,:ky_m+1,:sy_m+1,:sum_rm+0.01,:sum_gm+0.01,:sum_km+0.01,:sum_sm+0.01,
:pg_sym+1,:pg_rym+1,:pg_gym+1,:pg_kym+1);
i=i+1;
end
end
end;
@
COMMIT WORK;
@